[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index] [List Home]
Re: [p2-dev] How use updated custom touchpoint action in the same installation - resumption?

As you describe, the problem is caused by the fact that your customTouchpoint bundle is included strictly dependend upon by the product.
The way to solve this is to loosen up the requirement on the customTouchpoint bundle.

If you are using a feature based product, then in the feature.xml replace the "include" on the customTouchpoint by a "requires" since requires allow to express "ranges" instead of precise version.
If you are using a plugin based product, then you will need a p2.inf file to widen the range that the product IU has on the customTouchpoint bundle. See the section on "requires" at http://wiki.eclipse.org/Equinox/p2/Customizing_Metadata


HTH



-----Original Message-----
From: p2-dev-bounces@xxxxxxxxxxx [mailto:p2-dev-bounces@xxxxxxxxxxx] On Behalf Of Eugen Kondrashev
Sent: February-08-13 8:45 AM
To: p2-dev@xxxxxxxxxxx
Subject: [p2-dev] How use updated custom touchpoint action in the same installation - resumption?


Hi all,
I have the very same problem that is described here http://dev.eclipse.org/mhonarc/lists/p2-dev/msg01765.html
I need to use updated custom touch point action in the same update process.

I've taken tycho demo product.metaRequirements project as an example - http://git.eclipse.org/c/tycho/org.eclipse.tycho.git/tree/tycho-its/projects/product.metaRequirements.

The scenario is like this.
1. build pmr.product project
2. install pmr.product in eclipse (with workaround feature) 3. change logging at CustomTouchpointAction.java to see if it is executed during update 4. build pmr.product project again 4. update pmr.product from eclipse 5. See that console showing logging from the initial CustomTouchpointAction.java.

Instead I'd expect to see the logging according to changes done in 3rd step.

I've tried to change touchpoint bundle version during step 3 + specify this version in metaRequirements.0.range field of p2.inf file. But this leads to "Cannot complete the install because of a conflicting dependency" problem. Correct me if I'm wrong, but as I understand, this is because bundle declaring touchpoint extension needs to be singleton + root IU product is referencing it, so the bundle with custom touch point can't be updated.

Please let me know if I'm missing something, I need to be able to provide fixes for the bundle with custom touchpoint action.

Any help is really appreciated, because I've already spent more then 2 days on this problem.

Thanks,
Eugen Kondrashev.
_______________________________________________
p2-dev mailing list
p2-dev@xxxxxxxxxxx
https://dev.eclipse.org/mailman/listinfo/p2-dev